// Large.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Large.h"

void printLarge128(Large128 x)
{
	printf("---begin---\n");
	printf("%8x\n", unsigned(x.hi().hi()));
	printf("%8x\n", unsigned(x.hi().lo()));
	printf("%8x\n", unsigned(x.lo().hi()));
	printf("%8x\n", unsigned(x.lo().lo()));
	printf("---end---\n");
}

int _tmain(int argc, _TCHAR* argv[])
{
	{
		Large1024 x = 0;
		Large1024 y = 1;
		//Large1024 z = (y / x);
		//printLarge128(z.lo().lo().lo());
	}
	printLarge128(Large128::DivMax);
	// 1099511627776
	// 10000000000
	// ffff0000
	// FF FF000000 00000000
	// 4722294425275607285760
	Large1024 x = 0xffff0000;
	printf("sizeof(x) = %u\n", unsigned(sizeof(x)));
	Large1024 y(x);
	x = y;

	printLarge128(x.lo().lo().lo());

	x = x + y;
	printLarge128(x.lo().lo().lo());

	{
		Large1024 z = x - y;
		printf("z = ");
		printLarge128(z.lo().lo().lo());
	}

	x = x + x;
	printLarge128(x.lo().lo().lo());
	x = x + x;
	printLarge128(x.lo().lo().lo());

	for (int i = 0; i < 37; ++i)
	{
		x = x + x;
	}
	printLarge128(x.lo().lo().lo());
	// 0x 1000000,00000000
	Large128  t128  = Large128(Large64(0, 0x01000000));
	Large1024 t1024 = Large1024(Large512(Large256(t128)));
	x = x / t1024;
	printf("Divided:");
	printLarge128(x.lo().lo().lo());

	x = Large1024(2);
	y = Large1024(4);
	for (int i = 0; i < 6; ++i)
	{
		x = x * x;
		x = x / y;
		x = x * y;
	}
	x = x * x;
	printLarge128(x.lo().lo().hi());
	printLarge128(x.lo().lo().lo());
	x.shiftLeft(false);
	printLarge128(x.lo().lo().hi());
	printLarge128(x.lo().lo().lo());
	
	printLarge128(Large128::Max);

	printf("%x\n", unsigned(-int(2147483648)));
	return 0;
}

